var MODULE_NAME  = "Correct DMIS syntax";
var MODULE_VER   = "1.0";
var MODULE_TITLE = "Changes the keywords to correct case";

// Hello ! Check global variable "syntaxfile" if it targets to the correct syntax file!
var ed;
var syntaxfile = 'D:/ACER-C/Program Files/PSPad/Syntax/DMIS.INI';
var log;
var nOfRepl;

function Init() {
    menuName = "&" + MODULE_NAME;
    subMenu = "&" + "DMIS";
    addMenuItem(menuName, subMenu, "main", "CTRL+SHIFT+T" );
}


function main()
{
   var time = new Date();
   var time0 = time.getTime();
   
   ed = newEditor();
   ed.assignActiveEditor();
   log = newEditor();
   log.assignLog();
   log.text( '' );
   
	logOut( '*** DMIS Syntax corrector ***\n' );
   logOut( '(vs) 2008-03-04 \n');
   logOut( '\n' );
   
   var keyWords = readSyntaxFile();
   if ( !keyWords )
      return false;
   logOut( keyWords.length + ' keywords read. \n' );
   var rgXpWords = createRegExpArray( keyWords );

	var fileText = getFileText();
   var correctText = correctSyntax( fileText, keyWords, rgXpWords );

   writeCorrectText( correctText );

   time = new Date();
   var time1 = time.getTime();
   var time01 = (time1-time0) / 1000;

   logOut( 'Total time : ' + time01 + 's \n' );
   
   var timeperone = time01 / nOfRepl;
   logOut( 'Time per 1 replacement : ' + timeperone + 's \n' );
   
}


// this function reads the syntax file
// global variable "syntaxfile" must contain the correct path to syntax file!
function readSyntaxFile()
{

   var keyWords = new Array();
	var fso = new ActiveXObject( 'Scripting.FileSystemObject' );
	if ( !fso.FileExists( syntaxfile ) )
	{
	   echo( 'Syntax file not found! Please check the path in the head of the script!' );
	   logOut( 'Syntax file not found! Please check the path in the head of the script! \n' );
	   return false;
	}
   var fsSyntFile = fso.OpenTextFile( syntaxfile, 1, false );
   var doReading = false;
   
	var readRegExp = new RegExp( "([\[]KeyWords[0-9]?[\]])|([\[]ReservedWords[\]])", '' ); //   
   var noreadRegExp = new RegExp( "([\[]Settings[\]])" );

   while( !fsSyntFile.AtEndOfStream )
   {
	   var line = fsSyntFile.ReadLine();
	   
	   if ( noreadRegExp.exec( line ) != null ) //  line.match( noreadRegExp ) != null )
	   {
	      doReading = false;
	      continue;
		}
      
		if ( readRegExp.exec( line ) != null )  //( line.match( readRegExp ) != null )
      {
         doReading = true;
         continue;
		}
		
		if ( !doReading )
		   continue;
		
		line = trim( line, "=" );
		line = trim( line, " " );
		
		keyWords.push( line );      
	}
   fsSyntFile.Close();
   
   return keyWords;   
}


// this function creates array of regular expression objects ( one for each keyword )
function createRegExpArray( keyWords )
{
   var rgxparray = new Array();

   for ( var i=0; i < keyWords.length; i++ )
   {
	   var rg = new RegExp( "([ ,/\t]|^)(" + keyWords[i] + ")([ ,/(\t]|$)", "gim" );
// 	   rg.compile();
	   rgxparray.push( rg );
	}
	return rgxparray;
}


// this function returns text to be corrected
function getFileText()
{
   var txt = ed.text();
   return txt;
}



// CORRECT THE SYNTAX IN THE TEXT 
function correctSyntax( fileText, keyWords, rgXpWords )
{
   var nOfReplacements = 0;
   var newText = ''; 
   var splitText = fileText.split( '\n' );

   for ( var ln = 0; ln < splitText.length; ln++ )
   {
		 var clearedLine = clearLine( splitText[ln] );
	    for ( var kw = 0; kw < keyWords.length; kw++ )
	    {
		    while( rgXpWords[kw].exec( clearedLine ) != null )
		    {
		       //logOut( 'Match found for keyword ' + keyWords[kw] + ' on line ' + ln );
			    splitText[ln] = splitText[ln].replace( rgXpWords[kw], RegExp.$1 + keyWords[kw] + RegExp.$3 );
			    nOfReplacements++;
			    if ( RegExp.lastIndex > clearedLine.length-1 )
			       break;
			 }
		 }
		 newText += splitText[ln] + '\n';
	}
	logOut( nOfReplacements + ' replacements done. \n' );
	nOfRepl = nOfReplacements;
	return newText;
}



// writes the corrected text back
function writeCorrectText( correctText )
{
   ed.text( correctText );
}













// function removes all that is right to the comment chars and strings
function clearLine( line )
{
   var rgxpNewLine = new RegExp( '([\n]|[\f]|[\r])*', 'gm' );
   line = line.replace( rgxpNewLine, '' );
   
   var rgxpComment = new RegExp( "[\$][\$].*$", 'g' );
   line = line.replace( rgxpComment, '' );
   
   var rgxpString = new RegExp( "\'.*\'", 'g' );
   line = line.replace( rgxpString, '' );
   
   return line;
}



function trim( str, letter )
{
    if ( !letter )
       letter = " ";
    if ( !str )
       return str;
    while( str.substr( 0, 1 ) == letter )
    {
	    str = str.substr( 1, str.length -1 );
	 }
	 while( str.substr( str.length -1, 1 ) == letter )
	 {
	    str = str.substr( 0, str.length -1 );
	 }
	 return str;
}




function logOut( text )
{
   log.appendText( text );
}




